function [Nlist, MARK] = Phase3_p5_jlist(IPARAM,MCPARAM,LIK,MVN,struc,varargin)
%Accepts MARK as varargin to pick up from saved data. Omit for new
%analysis

logfile=struc.logfile;
Nlist=[];
csq=0.5*(2.4/sqrt(7))^2;
burnin=0.5; %proportion to remove from Olist;
SIG=csq*MVN.SIG;
A=chol(SIG)';

MCPARAM.N_markov=4; %No markov chains


%draw start vals
if size(varargin,2)==0
        MARK=[];
    for i2=1:MCPARAM.N_markov
        ThetaStar=struc.jlist(i2,1:6);
                ThetaStar(1)=log(ThetaStar(1));
                ThetaStar(2)=log(ThetaStar(2));
                ThetaStar(3)=log(ThetaStar(3)/(1-ThetaStar(3))); %logit transform
                ThetaStar(4)=log(ThetaStar(4));
                ThetaStar(5)=log(ThetaStar(5));

        MARK(i2).Olist=ThetaStar;
        
        i=1; %set this for the next step
        

            %get posterior density for the starting values
            ThetaStar=MARK(i2).Olist(1,1:6);
            ThetaStar(1)=exp(ThetaStar(1)); %burial dose
            ThetaStar(2)=exp(ThetaStar(2)); %sd of second normal
            ThetaStar(3)=exp(ThetaStar(3))/(1+exp(ThetaStar(3))); %inverse logit transform; p
            ThetaStar(4)=exp(ThetaStar(4)); %SG param a
            ThetaStar(5)=exp(ThetaStar(5)); %SG param b
            %ThetaStar(7)=exp(ThetaStar(7)); % z - deviation factor from specified ngrains
            
            ThetaStar

            %simulate a De dataset for the same size aliquots
            IPARAM.a=ThetaStar(4);
            IPARAM.b=ThetaStar(5);
            

                tempde=[];
                delist2=[];
                for i5=1:length(struc.de_isize(:,1))
                    IPARAM.isize=struc.de_isize(i5,1);
                    IPARAM.na=struc.de_isize(i5,2);                
                    tempde = genDe_R1_lin(IPARAM,ThetaStar,struc);
                    delist2=[delist2; tempde];
                end
  
            
            %find Pr(Y?X), where Y is the measured MAM3, and X is the modelled
            %parameters
            de_sorted=sortrows(delist2);
            startval=getWAV(de_sorted(1:ceil(length(de_sorted(:,1))*0.15),:));
            CAM=getCAM(delist2);
           
            switch struc.mamflag
                case 1
                    MAM3=getmam3(delist2,IPARAM.sigb(1),startval);
                case 2
                    MAM3=getmam3ul(delist2,IPARAM.sigb(1),startval);
            end

            T(1,1) = interp1(LIK.MA(:,1),LIK.MA(:,2),MAM3(1));
            T(1,2) = interp1(LIK.SIG(:,1),LIK.SIG(:,2),MAM3(3));
            T(1,3) = interp1(LIK.P(:,1),LIK.P(:,2),MAM3(4));
            T(1,4) = interp1(LIK.CAM(:,1),LIK.CAM(:,2),CAM(1));
            ind=find(isnan(T));
            T(ind)=0;
            

            priors(1)=evalprior(struc.prior.burial,ThetaStar(1));
            priors(2)=evalprior(struc.prior.sd2,ThetaStar(2));
            priors(3)=evalprior(struc.prior.p,ThetaStar(3));
            priors(4)=evalprior(struc.prior.A,ThetaStar(4));
            priors(5)=evalprior(struc.prior.B,ThetaStar(5));

            
            ind=find(isnan(priors));
            priors(ind)=0;
            
            %prodprior=Pr_p_moderate(ThetaStar(3))*Pr_sd2_moderate(ThetaStar(2))*Pr_gams(1)*Pr_gams(2);
            densThetaStar=prod(T([1 2 3 4]))*prod(priors); %posterior density
            MARK(i2).Olist(1,6)=densThetaStar;
            MARK(i2).Olist(1,7)=1;
            i=1; %set this for the next step
    end
        
    %end
else % continue from data provided
    MARK=varargin{1};
    MCPARAM.N_markov=length(MARK);
    i=length(MARK(1).Olist(:,1));
end


    
%n=MCPARAM.m; %temporary; replace this with while loop------------!!!!!!
k=0;
kk=0;
Rhat=[];
%i=1;
flag=10;
max_i=10000;
while or(flag>0,i<1000)
    i=i+1;
    for h=1:MCPARAM.N_markov
        
        %propose nw theta from jumping distr.
        
        z=randn(1,5)';
        theta=MARK(h).Olist(i-1,1:5);
        densTheta=MARK(h).Olist(i-1,6);
        x=theta'+A*z;
        ThetaStar=x';
        ThetaStar(1)=exp(ThetaStar(1)); ThetaStar(1)=max(ThetaStar(1),0.00001); % zero will crash genDe
        ThetaStar(2)=exp(ThetaStar(2)); ThetaStar(2)=max(ThetaStar(2),0.00001); % zero will crash genDe
        ThetaStar(3)=exp(ThetaStar(3))/(1+exp(ThetaStar(3))); ThetaStar(3)=min(ThetaStar(3),0.9999999999); ThetaStar(3)=max(ThetaStar(3),0.0000000001); %cannot logit 0 or 1
        ThetaStar(4:5)=exp(ThetaStar(4:5));
        ThetaStar=real(ThetaStar);
        
        %showme=[h ThetaStar]
        %simulate a De dataset for the same size aliquots
        IPARAM.a=ThetaStar(4);
        IPARAM.b=ThetaStar(5);
        

            tempde=[];
            delist2=[];
            for i5=1:length(struc.de_isize(:,1))
                IPARAM.isize=struc.de_isize(i5,1);
                IPARAM.na=struc.de_isize(i5,2);                
                tempde = genDe_R1_lin(IPARAM,ThetaStar,struc);
                delist2=[delist2; tempde];
            end


        %find Pr(Y?X), where Y is the measured MAM3, and X is the modelled
        de_sorted=sortrows(delist2);
        startval=getWAV(de_sorted(1:ceil(length(de_sorted(:,1))*0.15),:));
        CAM=getCAM(delist2);

        switch struc.mamflag
            case 1
                MAM3=getmam3(delist2,IPARAM.sigb(1),startval);
            case 2
                MAM3=getmam3ul(delist2,IPARAM.sigb(1),startval);
        end
            
        T(1,1) = interp1(LIK.MA(:,1),LIK.MA(:,2),MAM3(1));
        T(1,2) = interp1(LIK.SIG(:,1),LIK.SIG(:,2),MAM3(3));
        T(1,3) = interp1(LIK.P(:,1),LIK.P(:,2),MAM3(4));
        T(1,4) = interp1(LIK.CAM(:,1),LIK.CAM(:,2),CAM(1));
        ind=find(isnan(T));
        T(ind)=0;
        
        priors(1)=evalprior(struc.prior.burial,ThetaStar(1));
        priors(2)=evalprior(struc.prior.sd2,ThetaStar(2));
        priors(3)=evalprior(struc.prior.p,ThetaStar(3));
        priors(4)=evalprior(struc.prior.A,ThetaStar(4)); 
        priors(5)=evalprior(struc.prior.B,ThetaStar(5));

        
        %ListPr(i,:)=ceil(priors);
        ind=find(isnan(priors));
        priors(ind)=0;
        
        densThetaStar=prod(T([1 2 3 4]))*prod(priors); %posterior density


            r=densThetaStar/densTheta;
            R2=rand;
            if R2<min(r,1)
                ThetaStar(1)=log(ThetaStar(1));
                ThetaStar(2)=log(ThetaStar(2));
                ThetaStar(3)=log(ThetaStar(3)/(1-ThetaStar(3))); %logit transform
                ThetaStar(4)=log(ThetaStar(4));
                ThetaStar(5)=log(ThetaStar(5));
                theta=ThetaStar;
                densTheta=densThetaStar;
                acc=1;
            else
                acc=0;
            end
      
        
        MARK(h).Olist(i,:)=[theta densTheta acc];
 
    end
    
    k=k+1;
    if k==20
        k=0;
        kk=kk+1;
        Omonster=[];
        acclist=[];
        for h=1:MCPARAM.N_markov
            templist=MARK(h).Olist(ceil(i*burnin):i,:);
            Omonster(:,:,h)=templist(:,1:5);
            acclist(:,h)=MARK(h).Olist(ceil(i*burnin):i,7);
        end
        vbar=mean(Omonster); %size(1,3,w), called vbardotj in Gelman p296
        vbardotdot=mean(vbar,3); %size(1,3,1)
        u=length(Omonster(:,1,1)); %n in Gelman p296
        w=MCPARAM.N_markov;         %m in Gelman p296
        s2=(1/(u-1))*sum((Omonster-repmat(vbar,u,1)).^2);
        W=mean(s2,3);
        B=(u/(w-1))*sum((vbar-repmat(vbardotdot,[1 1 w])).^2,3);
        varhatplus=((u-1)/u)*W+B/u;
        Rhat(kk,:)=sqrt(varhatplus./W)
        acc_ratio=mean(mean(acclist))
        %new logging:
            message=sprintf('%1.2f %1.2f %1.2f %1.2f %1.2f %1.2f %1.2f %\n',Rhat(kk,:));
            logthis(logfile,['i=' int2str(i) ' acc=' num2str(acc_ratio,2) ' rhat: ' message]);
        %acc_pr=mean(ListPr);
            %message=sprintf('%1.2f %1.2f %1.2f %1.2f %1.2f %1.2f %1.2f %\n',acc_pr);
            %logthis(logfile,['i=' int2str(i) ' acc=' num2str(acc_ratio,2) ' acc_pr: ' message]);
        
        flag=sum(Rhat(kk,:)>struc.tolerance);
        %i
        if i>max_i
            flag=0;
            message='MAX ITERATIONS REACHED - NOT CONVERGED!!';
            logthis(logfile,message);
        end
        save MARK MARK        
    end
end
for h=1:MCPARAM.N_markov
    templist=MARK(h).Olist(ceil(i*burnin):i,:);
    Nlist=[Nlist; templist];
end
Nlist(:,1)=exp(Nlist(:,1));
Nlist(:,2)=exp(Nlist(:,2));
Nlist(:,3)=exp(Nlist(:,3))./(1+exp(Nlist(:,3))); %inverse logit transform
Nlist(:,4)=exp(Nlist(:,4));
Nlist(:,5)=exp(Nlist(:,5));
Nlist(:,6)=exp(Nlist(:,6));
    