function [rec_start jlist] = find_Ph1_starts_p5(struc,IPARAM,MCPARAM,LIK)
% select stating values for the parameters
    
% Pulls values from the priors, tests to see if they have non-zero density,
% then lists them. IF THE PRIORS ARE TOO BIG, THIS WILL TAKE AGES, SO
% MODIFY THIS SCRIPT

j=0;
jlist=zeros(100,6);


n=1000;
x=struc.prior.burial(:,1); y=struc.prior.burial(:,2);
xi=[linspace(min(x),max(x),n)]';
yi=interp1(x,y,xi);
ind=find(isnan(yi));
yi(ind)=0;
x1=xi; y1=yi;

x=struc.prior.sd2(:,1); y=struc.prior.sd2(:,2);
xi=[linspace(min(x),max(x),n)]';
yi=interp1(x,y,xi);
ind=find(isnan(yi));
yi(ind)=0;
x2=xi; y2=yi;

[tmu, tsig]=normfit(x2,[],[],y2);
X=x2;
Y=normpdf(X,tmu,tsig); Y=Y/max(Y); 

x=struc.prior.p(:,1); y=struc.prior.p(:,2);
xi=[linspace(min(x),max(x),n)]';
yi=interp1(x,y,xi);
ind=find(isnan(yi));
yi(ind)=0;
x3=xi; y3=yi;

x=struc.prior.A(:,1); y=struc.prior.A(:,2);
xi=[linspace(min(x),max(x),n)]';
yi=interp1(x,y,xi);
ind=find(isnan(yi));
yi(ind)=0;
x4=xi; y4=yi;

x=struc.prior.B(:,1); y=struc.prior.B(:,2);
xi=[linspace(min(x),max(x),n)]';
yi=interp1(x,y,xi);
ind=find(isnan(yi));
yi(ind)=0;
x5=xi; y5=yi;

%x=struc.prior.z(:,1); y=struc.prior.z(:,2);
%xi=[linspace(min(x),max(x),n)]';
%yi=interp1(x,y,xi);
%ind=find(isnan(yi));
%yi(ind)=0;
%x7=xi; y7=yi;

icount=0;
while j<30
    icount=icount+1;
    %draw starting values
    %Olist=[]; %storage for each Markov chain
    Tburial=randsample(x1,1,true,y1);
    
    if icount>300
        Tsd2 = randsample(x2,1,true,y2.*(1-Y));
    else
        Tsd2 = randsample(x2,1,true,y2);
    end
    %Tsd2=randn*(5)+3; Tsd2=min(Tsd2,8); Tsd2=max(Tsd2,1);
    Tp = randsample(x3,1,true,y3);
        
    %TSGsigb=randn*0.05+0.25; TSGsigb=min(TSGsigb,0.45); TSGsigb=max(TSGsigb,0.08);
    %TSGsigb=randsample(struc.prior.SGsigb(:,1),1,true,struc.prior.SGsigb(:,2));
    
    Ta=randsample(x4,1,true,y4);
    Tb=randsample(x5,1,true,y5);
    %Tz=randsample(x7,1,true,y7);
        %showme=[icount j Tburial Tsd2 Tp TSGsigb Ta Tb Tz]
        
        theta=[Tburial Tsd2 Tp Ta Tb];
        ThetaStar=theta;
        IPARAM.a=Ta; %temp - get genDe to accept a and b in thetastar
        IPARAM.b=Tb;
        
        %simulate a De dataset for the same size aliquots     
        %if length(struc.de_isize(:,1))>1
            %num_sizes=length(struc.de_isize(:,1));
            %tempde=[];
            delist2=[];
            for i5=1:length(struc.de_isize(:,1))
                IPARAM.isize=round(struc.de_isize(i5,1));
                IPARAM.na=struc.de_isize(i5,2);                
                tempde = genDe_R1_lin(IPARAM,ThetaStar,struc);
                delist2=[delist2; tempde];
            end

        %find Pr(Y?X), where Y is the measured MAM3, and X is the modelled
        %parameters
        de_sorted=sortrows(delist2);
        startval=getWAV(de_sorted(1:ceil(length(de_sorted(:,1))*0.15),:));
        CAM=getCAM(delist2);
        %startval=mean([min(delist2(:,1)) CAM(1)]);
        switch struc.mamflag
            case 1
                MAM3=getmam3(delist2,IPARAM.sigb(1),startval);
            case 2
                MAM3=getmam3ul(delist2,IPARAM.sigb(1),startval);
        end


        T(1,1) = interp1(LIK.MA(:,1),LIK.MA(:,2),MAM3(1));
        T(1,2) = interp1(LIK.SIG(:,1),LIK.SIG(:,2),MAM3(3));
        T(1,3) = interp1(LIK.P(:,1),LIK.P(:,2),MAM3(4));
        T(1,4) = interp1(LIK.CAM(:,1),LIK.CAM(:,2),CAM(1));
        ind=find(isnan(T));
        T(ind)=0;
        
        priors(1)=evalprior(struc.prior.burial,ThetaStar(1));
        priors(2)=evalprior(struc.prior.sd2,ThetaStar(2));
        priors(3)=evalprior(struc.prior.p,ThetaStar(3));
        priors(4)=evalprior(struc.prior.A,ThetaStar(4));
        priors(5)=evalprior(struc.prior.B,ThetaStar(5));
        
        
        ind=find(isnan(priors));
        priors(ind)=0;

        densThetaStar=prod(T([1 2 3 4]))*prod(priors); %posterior density
        
        %rec_start(h,:)=[theta densThetaStar];
        
        if densThetaStar>0
            j=j+1;
            jlist(j,:)=[theta densThetaStar];
        end
end
    
jlist=sortrows(jlist,-6);
rec_start=jlist(1:MCPARAM.N_markov,:);







