function de = genDe_R1_lin(IPARAM,ThetaStar,struc)
%generate De assuming 1-reg linear curve.



%simulate a De dataset for the same size aliquots
DR=struc.DR;
CRIT=struc.CRIT;
j=0;
de=[];
%simultate MG aliquot:

SGsigb=IPARAM.SGsigb;

while j<IPARAM.na
    j=j+1;
    
    
    IPARAM.a=real(IPARAM.a); IPARAM.b=real(IPARAM.b); IPARAM.isize=real(IPARAM.isize);  % SORT THIS OUT
    
    R = gamrnd(IPARAM.a,IPARAM.b,IPARAM.isize,1);
    D1 = randn(IPARAM.isize,1)*(SGsigb*ThetaStar(1))+ThetaStar(1); % burial dose
    
    bn=binornd(IPARAM.isize,1-ThetaStar(3));
    D2=abs(randn(bn,1))*ThetaStar(2);
    D3=D1;
    if bn>0
        D3(1:bn)=D3(1:bn)+D2;
    end


    signal=R.*D3;
    DR.ln.sig=poissrnd(sum(signal));
    DR.ln.rse=sqrt(DR.ln.sig)/DR.ln.sig;

    signal=R.*DR.tn.dose;
    DR.tn.sig=poissrnd(sum(signal));
    DR.tn.rse=sqrt(DR.tn.sig)/DR.tn.sig;

    signal=R.*DR.r1.dose;
    DR.r1.sig=poissrnd(sum(signal));
    DR.r1.rse=sqrt(DR.r1.sig)/DR.r1.sig;

    signal=R.*DR.t1.dose;
    DR.t1.sig=poissrnd(sum(signal));
    DR.t1.rse=sqrt(DR.t1.sig)/DR.t1.sig;

    signal=R.*DR.ry.dose;
    DR.ry.sig=poissrnd(sum(signal));
    DR.ry.rse=sqrt(DR.ry.sig)/DR.ry.sig;

    signal=R.*DR.ty.dose;
    DR.ty.sig=poissrnd(sum(signal));
    DR.ty.rse=sqrt(DR.ty.sig)/DR.ty.sig;

    
    lntn.sig=DR.ln.sig/DR.tn.sig;
    lntn.rse=sqrt(DR.ln.rse^2+DR.tn.rse^2);

    r1t1.sig=DR.r1.sig/DR.t1.sig;
    r1t1.rse=sqrt(DR.r1.rse^2+DR.t1.rse^2);

    ryty.sig=DR.ry.sig/DR.ty.sig;
    ryty.rse=sqrt(DR.ry.rse^2+DR.ty.rse^2);

    %rejection criteria
    if (ryty.sig/r1t1.sig)>=CRIT.rcy.lower && (ryty.sig/r1t1.sig)<=CRIT.rcy.upper
        de(j,1)=(lntn.sig/r1t1.sig)*DR.r1.dose;
        de(j,2)=de(j,1)*sqrt(lntn.rse^2+r1t1.rse^2);
        if prod(de(j,:))>0
            if sum(isnan(de(j,:)))>0
                j=j-1;
            end
        else
            j=j-1;                    
        end                   
    else
        j=j-1;
    end
end