function LIK = getLIK(delist,IPARAM,M,mamflag)
% Define the boostrap likelihoods.

% These are the bootstrap likelihoods of Cunningham & Wallinga (2012,
% Quat.Geoch). HOWEVER- this time the likelihoods are defined for all
% parameters of the MAM3 (Galbraiths gamma, sigma and p). IN ADDITION, the
% a bootstrap likelihood is defined for the CAM

%create bootstrap likelihoods for this dataset. theta, p, sd
switch mamflag
    case 1
        CAM=getCAM(delist);
    case 2
        [CAM ~]=getCAMul(delist);
end
startval=mean([min(delist(:,1)) CAM(1)]); %but now using WAV within BootRecyclingGAM

site.de=delist;
site.start=startval;
site.dr=1;
site.name='whatever';
site = BootRecyclingGAM(site,IPARAM.sigb,M,mamflag);
switch mamflag
    case 1
        siteCAM = BootRecyclingCAM(site,IPARAM.sigb,M,3);
    case 2
        siteCAM = BootRecyclingCAM(site,IPARAM.sigb,M,4);
end
site.pairs


%min_age
tsite=site;
tsite.pairs=site.pairs(:,1:2);
tsite=MakeLikelihoodGAM(tsite,5,0,0,4);
LIK.MA=tsite.likelihood;


%sigma
tsite=site;
tsite.pairs=site.pairs(:,3:4);
tsite=MakeLikelihoodGAM(tsite,7,0,0,4);
LIK.SIG=tsite.likelihood;

%p
tsite=site;
tsite.pairs=site.pairs(:,5:6);
tsite=MakeLikelihoodGAM(tsite,7,0,0,4);
LIK.P=tsite.likelihood;


%CAM
tsite=siteCAM;
%tsite.pairs already exists correctly
tsite=MakeLikelihoodGAM(tsite,7,0,0,4);
LIK.CAM=tsite.likelihood;

